Package org.eclipse.cdt.core.templateengine

## Class SharedDefaults

- java.lang.Object
- - java.util.AbstractMap<K,​V>
  - - java.util.HashMap<String,​String>
    - - org.eclipse.cdt.core.templateengine.SharedDefaults

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Map<String,​String>`

    public class SharedDefaults
    extends HashMap<String,​String>

Processes the shared default values. Updates and Persists new key - value (default) pair

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class java.util.AbstractMap

`AbstractMap.SimpleEntry<K extends Object,​V extends Object>, AbstractMap.SimpleImmutableEntry<K extends Object,​V extends Object>`

### Nested classes/interfaces inherited from interface java.util.Map

`Map.Entry<K extends Object,​V extends Object>`

### Field Summary

Fields
`Document` `document`
`static String` `GET`
`static String` `ResourceFolder` Specifies the folder name present in the plugin
`static String` `SET` Static reference string for getting (GET) and storing (SET) shareddefaults.xml

### Constructor Summary

Constructors
`SharedDefaults()` Default Constructor for creating and instantiating objects.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `addToBackEndStorage​(String name, String value)` Adds data to the backend XML (persistence) Data obtained from the PreferencePage GUI.
`void` `deleteBackEndStorage​(String[] deleteName)` Deletes the key-value pair from the backend with Key as identifier.
`static SharedDefaults` `getInstance()`
`Map<String,​String>` `getSharedDefaultsMap()` This method returns the latest key value pair (HashMap)
`void` `persistSharedValueMap()` This method persists the latest data (HashMap) in the XML file New data obtained from the PreferencePage GUI.
`void` `updateShareDefaultsMap​(Map<String,​String> sharedMap)` This method updates the HashMap with new key-value pair into the XML file
`void` `updateToBackEndStorage​(String updateName, String updateValue)` Updates backend with changed value for a specific key(name)

### Methods inherited from class java.util.HashMap

`clear, clone, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, forEach, get, getOrDefault, isEmpty, keySet, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size, values`

### Methods inherited from class java.util.AbstractMap

`equals, hashCode, toString`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Map

`equals, hashCode`

### Field Detail

#### document

    public Document document

#### SET

    public static final String SET

Static reference string for getting (GET) and storing (SET) shareddefaults.xml

See Also:
  Constant Field Values

#### GET

    public static final String GET

See Also:
  Constant Field Values

#### ResourceFolder

    public static final String ResourceFolder

Specifies the folder name present in the plugin

See Also:
  Constant Field Values

### Constructor Detail

#### SharedDefaults

    public SharedDefaults()

Default Constructor for creating and instantiating objects. On the startup of Template Engine, if it checks for the existence of TempSharedDefaultsXML file, then it is determined that the last Template Engine process under went some System destructive events and takes up reconstructive process to regain the consistent data by persisting all information first into temporary file and then into actual file.

### Method Detail

#### getInstance

    public static SharedDefaults getInstance()

Returns:
  the shared SharedDefaults Instance

#### updateShareDefaultsMap

    public void updateShareDefaultsMap​(Map<String,​String> sharedMap)

This method updates the HashMap with new key-value pair into the XML file

Parameters:
  `sharedMap` -

#### persistSharedValueMap

    public void persistSharedValueMap()

This method persists the latest data (HashMap) in the XML file New data obtained from the PreferencePage GUI.

#### getSharedDefaultsMap

    public Map<String,​String> getSharedDefaultsMap()

This method returns the latest key value pair (HashMap)

Returns:
  HashMap

#### addToBackEndStorage

    public void addToBackEndStorage​(String name,
                                    String value)

Adds data to the backend XML (persistence) Data obtained from the PreferencePage GUI.

#### updateToBackEndStorage

    public void updateToBackEndStorage​(String updateName,
                                       String updateValue)

Updates backend with changed value for a specific key(name)

Parameters:
  `updateName` -
  `updateValue` -

#### deleteBackEndStorage

    public void deleteBackEndStorage​(String[] deleteName)

Deletes the key-value pair from the backend with Key as identifier.

Parameters:
  `deleteName` -